aboutsummaryrefslogtreecommitdiffstats
path: root/tests/bandwidth-server-many-up
diff options
context:
space:
mode:
Diffstat (limited to '')
-rwxr-xr-xtests/bandwidth-server-many-up225
-rw-r--r--tests/bandwidth-server-many-up.c143
-rw-r--r--tests/bandwidth-server-many-up.obin0 -> 15216 bytes
3 files changed, 368 insertions, 0 deletions
diff --git a/tests/bandwidth-server-many-up b/tests/bandwidth-server-many-up
new file mode 100755
index 0000000..85a88ea
--- /dev/null
+++ b/tests/bandwidth-server-many-up
@@ -0,0 +1,225 @@
+#! /bin/bash
+
+# bandwidth-server-many-up - temporary wrapper script for .libs/bandwidth-server-many-up
+# Generated by libtool (GNU libtool) 2.4 Debian-2.4-3
+#
+# The bandwidth-server-many-up program cannot be directly executed until all the libtool
+# libraries that it depends on are installed.
+#
+# This wrapper script should never be moved out of the build directory.
+# If it is, it will not operate correctly.
+
+# Sed substitution that helps us do robust quoting. It backslashifies
+# metacharacters that are still active within double-quoted strings.
+sed_quote_subst='s/\([`"$\\]\)/\\\1/g'
+
+# Be Bourne compatible
+if test -n "${ZSH_VERSION+set}" && (emulate sh) >/dev/null 2>&1; then
+ emulate sh
+ NULLCMD=:
+ # Zsh 3.x and 4.x performs word splitting on ${1+"$@"}, which
+ # is contrary to our usage. Disable this feature.
+ alias -g '${1+"$@"}'='"$@"'
+ setopt NO_GLOB_SUBST
+else
+ case `(set -o) 2>/dev/null` in *posix*) set -o posix;; esac
+fi
+BIN_SH=xpg4; export BIN_SH # for Tru64
+DUALCASE=1; export DUALCASE # for MKS sh
+
+# The HP-UX ksh and POSIX shell print the target directory to stdout
+# if CDPATH is set.
+(unset CDPATH) >/dev/null 2>&1 && unset CDPATH
+
+relink_command="(cd /home/jmccrohan/bin/libmodbus/tests; { test -z \"\${LIBRARY_PATH+set}\" || unset LIBRARY_PATH || { LIBRARY_PATH=; export LIBRARY_PATH; }; }; { test -z \"\${COMPILER_PATH+set}\" || unset COMPILER_PATH || { COMPILER_PATH=; export COMPILER_PATH; }; }; { test -z \"\${GCC_EXEC_PREFIX+set}\" || unset GCC_EXEC_PREFIX || { GCC_EXEC_PREFIX=; export GCC_EXEC_PREFIX; }; }; { test -z \"\${LD_RUN_PATH+set}\" || unset LD_RUN_PATH || { LD_RUN_PATH=; export LD_RUN_PATH; }; }; { test -z \"\${LD_LIBRARY_PATH+set}\" || unset LD_LIBRARY_PATH || { LD_LIBRARY_PATH=; export LD_LIBRARY_PATH; }; }; PATH=/usr/sbin:/usr/bin:/sbin:/bin:/usr/bin/X11; export PATH; gcc -g -O2 -g -O2 -Wall -Werror -o \$progdir/\$file bandwidth-server-many-up.o ../src/.libs/libmodbus.so -Wl,-rpath -Wl,/home/jmccrohan/bin/libmodbus/src/.libs)"
+
+# This environment variable determines our operation mode.
+if test "$libtool_install_magic" = "%%%MAGIC variable%%%"; then
+ # install mode needs the following variables:
+ generated_by_libtool_version='2.4'
+ notinst_deplibs=' ../src/libmodbus.la'
+else
+ # When we are sourced in execute mode, $file and $ECHO are already set.
+ if test "$libtool_execute_magic" != "%%%MAGIC variable%%%"; then
+ file="$0"
+
+# A function that is used when there is no print builtin or printf.
+func_fallback_echo ()
+{
+ eval 'cat <<_LTECHO_EOF
+$1
+_LTECHO_EOF'
+}
+ ECHO="printf %s\\n"
+ fi
+
+# Very basic option parsing. These options are (a) specific to
+# the libtool wrapper, (b) are identical between the wrapper
+# /script/ and the wrapper /executable/ which is used only on
+# windows platforms, and (c) all begin with the string --lt-
+# (application programs are unlikely to have options which match
+# this pattern).
+#
+# There are only two supported options: --lt-debug and
+# --lt-dump-script. There is, deliberately, no --lt-help.
+#
+# The first argument to this parsing function should be the
+# script's ../libtool value, followed by no.
+lt_option_debug=
+func_parse_lt_options ()
+{
+ lt_script_arg0=$0
+ shift
+ for lt_opt
+ do
+ case "$lt_opt" in
+ --lt-debug) lt_option_debug=1 ;;
+ --lt-dump-script)
+ lt_dump_D=`$ECHO "X$lt_script_arg0" | /bin/sed -e 's/^X//' -e 's%/[^/]*$%%'`
+ test "X$lt_dump_D" = "X$lt_script_arg0" && lt_dump_D=.
+ lt_dump_F=`$ECHO "X$lt_script_arg0" | /bin/sed -e 's/^X//' -e 's%^.*/%%'`
+ cat "$lt_dump_D/$lt_dump_F"
+ exit 0
+ ;;
+ --lt-*)
+ $ECHO "Unrecognized --lt- option: '$lt_opt'" 1>&2
+ exit 1
+ ;;
+ esac
+ done
+
+ # Print the debug banner immediately:
+ if test -n "$lt_option_debug"; then
+ echo "bandwidth-server-many-up:bandwidth-server-many-up:${LINENO}: libtool wrapper (GNU libtool) 2.4 Debian-2.4-3" 1>&2
+ fi
+}
+
+# Used when --lt-debug. Prints its arguments to stdout
+# (redirection is the responsibility of the caller)
+func_lt_dump_args ()
+{
+ lt_dump_args_N=1;
+ for lt_arg
+ do
+ $ECHO "bandwidth-server-many-up:bandwidth-server-many-up:${LINENO}: newargv[$lt_dump_args_N]: $lt_arg"
+ lt_dump_args_N=`expr $lt_dump_args_N + 1`
+ done
+}
+
+# Core function for launching the target application
+func_exec_program_core ()
+{
+
+ if test -n "$lt_option_debug"; then
+ $ECHO "bandwidth-server-many-up:bandwidth-server-many-up:${LINENO}: newargv[0]: $progdir/$program" 1>&2
+ func_lt_dump_args ${1+"$@"} 1>&2
+ fi
+ exec "$progdir/$program" ${1+"$@"}
+
+ $ECHO "$0: cannot exec $program $*" 1>&2
+ exit 1
+}
+
+# A function to encapsulate launching the target application
+# Strips options in the --lt-* namespace from $@ and
+# launches target application with the remaining arguments.
+func_exec_program ()
+{
+ for lt_wr_arg
+ do
+ case $lt_wr_arg in
+ --lt-*) ;;
+ *) set x "$@" "$lt_wr_arg"; shift;;
+ esac
+ shift
+ done
+ func_exec_program_core ${1+"$@"}
+}
+
+ # Parse options
+ func_parse_lt_options "$0" ${1+"$@"}
+
+ # Find the directory that this script lives in.
+ thisdir=`$ECHO "$file" | /bin/sed 's%/[^/]*$%%'`
+ test "x$thisdir" = "x$file" && thisdir=.
+
+ # Follow symbolic links until we get to the real thisdir.
+ file=`ls -ld "$file" | /bin/sed -n 's/.*-> //p'`
+ while test -n "$file"; do
+ destdir=`$ECHO "$file" | /bin/sed 's%/[^/]*$%%'`
+
+ # If there was a directory component, then change thisdir.
+ if test "x$destdir" != "x$file"; then
+ case "$destdir" in
+ [\\/]* | [A-Za-z]:[\\/]*) thisdir="$destdir" ;;
+ *) thisdir="$thisdir/$destdir" ;;
+ esac
+ fi
+
+ file=`$ECHO "$file" | /bin/sed 's%^.*/%%'`
+ file=`ls -ld "$thisdir/$file" | /bin/sed -n 's/.*-> //p'`
+ done
+
+ # Usually 'no', except on cygwin/mingw when embedded into
+ # the cwrapper.
+ WRAPPER_SCRIPT_BELONGS_IN_OBJDIR=no
+ if test "$WRAPPER_SCRIPT_BELONGS_IN_OBJDIR" = "yes"; then
+ # special case for '.'
+ if test "$thisdir" = "."; then
+ thisdir=`pwd`
+ fi
+ # remove .libs from thisdir
+ case "$thisdir" in
+ *[\\/].libs ) thisdir=`$ECHO "$thisdir" | /bin/sed 's%[\\/][^\\/]*$%%'` ;;
+ .libs ) thisdir=. ;;
+ esac
+ fi
+
+ # Try to get the absolute directory name.
+ absdir=`cd "$thisdir" && pwd`
+ test -n "$absdir" && thisdir="$absdir"
+
+ program=lt-'bandwidth-server-many-up'
+ progdir="$thisdir/.libs"
+
+ if test ! -f "$progdir/$program" ||
+ { file=`ls -1dt "$progdir/$program" "$progdir/../$program" 2>/dev/null | /bin/sed 1q`; \
+ test "X$file" != "X$progdir/$program"; }; then
+
+ file="$$-$program"
+
+ if test ! -d "$progdir"; then
+ mkdir "$progdir"
+ else
+ rm -f "$progdir/$file"
+ fi
+
+ # relink executable if necessary
+ if test -n "$relink_command"; then
+ if relink_command_output=`eval $relink_command 2>&1`; then :
+ else
+ printf %s\n "$relink_command_output" >&2
+ rm -f "$progdir/$file"
+ exit 1
+ fi
+ fi
+
+ mv -f "$progdir/$file" "$progdir/$program" 2>/dev/null ||
+ { rm -f "$progdir/$program";
+ mv -f "$progdir/$file" "$progdir/$program"; }
+ rm -f "$progdir/$file"
+ fi
+
+ if test -f "$progdir/$program"; then
+ if test "$libtool_execute_magic" != "%%%MAGIC variable%%%"; then
+ # Run the actual program with our arguments.
+ func_exec_program ${1+"$@"}
+ fi
+ else
+ # The program doesn't exist.
+ $ECHO "$0: error: \`$progdir/$program' does not exist" 1>&2
+ $ECHO "This script is just a wrapper for $program." 1>&2
+ $ECHO "See the libtool documentation for more information." 1>&2
+ exit 1
+ fi
+fi
diff --git a/tests/bandwidth-server-many-up.c b/tests/bandwidth-server-many-up.c
new file mode 100644
index 0000000..02968c1
--- /dev/null
+++ b/tests/bandwidth-server-many-up.c
@@ -0,0 +1,143 @@
+/*
+ * Copyright © 2009-2010 Stéphane Raimbault <stephane.raimbault@gmail.com>
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <stdio.h>
+#include <unistd.h>
+#include <string.h>
+#include <stdlib.h>
+#include <errno.h>
+#include <signal.h>
+
+#include <modbus.h>
+
+#if defined(_WIN32)
+#include <ws2tcpip.h>
+#else
+#include <sys/socket.h>
+#include <netinet/in.h>
+#include <arpa/inet.h>
+#endif
+
+#define NB_CONNECTION 5
+
+modbus_t *ctx = NULL;
+int server_socket;
+modbus_mapping_t *mb_mapping;
+
+static void close_sigint(int dummy)
+{
+ close(server_socket);
+ modbus_free(ctx);
+ modbus_mapping_free(mb_mapping);
+
+ exit(dummy);
+}
+
+int main(void)
+{
+ int master_socket;
+ int rc;
+ fd_set refset;
+ fd_set rdset;
+
+ /* Maximum file descriptor number */
+ int fdmax;
+
+ ctx = modbus_new_tcp("127.0.0.1", 1502);
+
+ mb_mapping = modbus_mapping_new(MODBUS_MAX_READ_BITS, 0,
+ MODBUS_MAX_READ_REGISTERS, 0);
+ if (mb_mapping == NULL) {
+ fprintf(stderr, "Failed to allocate the mapping: %s\n",
+ modbus_strerror(errno));
+ modbus_free(ctx);
+ return -1;
+ }
+
+ server_socket = modbus_tcp_listen(ctx, NB_CONNECTION);
+
+ signal(SIGINT, close_sigint);
+
+ /* Clear the reference set of socket */
+ FD_ZERO(&refset);
+ /* Add the server socket */
+ FD_SET(server_socket, &refset);
+
+ /* Keep track of the max file descriptor */
+ fdmax = server_socket;
+
+ for (;;) {
+ rdset = refset;
+ if (select(fdmax+1, &rdset, NULL, NULL, NULL) == -1) {
+ perror("Server select() failure.");
+ close_sigint(1);
+ }
+
+ /* Run through the existing connections looking for data to be
+ * read */
+ for (master_socket = 0; master_socket <= fdmax; master_socket++) {
+
+ if (FD_ISSET(master_socket, &rdset)) {
+ if (master_socket == server_socket) {
+ /* A client is asking a new connection */
+ socklen_t addrlen;
+ struct sockaddr_in clientaddr;
+ int newfd;
+
+ /* Handle new connections */
+ addrlen = sizeof(clientaddr);
+ memset(&clientaddr, 0, sizeof(clientaddr));
+ newfd = accept(server_socket, (struct sockaddr *)&clientaddr, &addrlen);
+ if (newfd == -1) {
+ perror("Server accept() error");
+ } else {
+ FD_SET(newfd, &refset);
+
+ if (newfd > fdmax) {
+ /* Keep track of the maximum */
+ fdmax = newfd;
+ }
+ printf("New connection from %s:%d on socket %d\n",
+ inet_ntoa(clientaddr.sin_addr), clientaddr.sin_port, newfd);
+ }
+ } else {
+ /* An already connected master has sent a new query */
+ uint8_t query[MODBUS_TCP_MAX_ADU_LENGTH];
+
+ modbus_set_socket(ctx, master_socket);
+ rc = modbus_receive(ctx, query);
+ if (rc != -1) {
+ modbus_reply(ctx, query, rc, mb_mapping);
+ } else {
+ /* Connection closed by the client, end of server */
+ printf("Connection closed on socket %d\n", master_socket);
+ close(master_socket);
+
+ /* Remove from reference set */
+ FD_CLR(master_socket, &refset);
+
+ if (master_socket == fdmax) {
+ fdmax--;
+ }
+ }
+ }
+ }
+ }
+ }
+
+ return 0;
+}
diff --git a/tests/bandwidth-server-many-up.o b/tests/bandwidth-server-many-up.o
new file mode 100644
index 0000000..0b6254d
--- /dev/null
+++ b/tests/bandwidth-server-many-up.o
Binary files differ